#include <stdio.h>
#include <windows.h>

#include "resource.h"

#include "./BMPEncoder.h"

#define DLLExport   __declspec( dllexport )

// Prototypes
extern "C" DLLExport void* OnCreate(HINSTANCE dllInstance, HWND owner);
extern "C" DLLExport void OnDestroy(void* context);
extern "C" DLLExport char* GetName();
extern "C" DLLExport int GetUberNESMovieEncoderPluginVersion();
extern "C" DLLExport void ShowOptions(void* context);
extern "C" DLLExport bool OnStartEncoding(void* context, const char* movieFile);
extern "C" DLLExport bool OnStopEncoding(void * context);
extern "C" DLLExport void OnFrame(void* context, const unsigned char* videoFrame, const unsigned char* audioFrame);


// Create instance of plugin
extern "C" DLLExport void* OnCreate(HINSTANCE instance, HWND owner) {
    return (void*) (new BMPEncoder);
}

// Destroy instance of plugin
extern "C" DLLExport void OnDestroy(void* context) {
    BMPEncoder* encoder = (BMPEncoder*)context;
    delete context;
}

// Get name of plugin
extern "C" DLLExport char* GetName() {
    return ".BMP Encoder";
}

// Get plugin version / validate plugin function
extern "C" DLLExport int GetUberNESMovieEncoderPluginVersion() {
    return 0x10;
}

extern "C" DLLExport void ShowOptions(void* context) {
}

extern "C" bool OnStartEncoding(void* context, const char* movieFile) {
    BMPEncoder* encoder = (BMPEncoder*)context;
    return encoder->onStartEncoding(movieFile);
}

extern "C" bool OnStopEncoding(void* context) {
    BMPEncoder* encoder = (BMPEncoder*)context;
    return encoder->onStopEncoding();
}

// Video format is 24-bit color, RGB format.  Image is 256x224, so video buffer size is 256 * 224 * 3 = 172032 bytes
extern "C" void OnFrame(void* context, const unsigned char* videoFrame, const unsigned char* audioFrame) {
    BMPEncoder* encoder = (BMPEncoder*)context;
    return encoder->clock(videoFrame, audioFrame);
}