#ifndef H_XVIDENCODER
#define H_XVIDENCODER

#include "../Revel/include/revel.h"

#include <map>
#include <windows.h>


#define OPTION_VIDEO_QUALITY    "Video.quality"
#define OPTION_VIDEO_FRAMERATE  "Video.framerate"
#define OPTION_AUDIO_SAMPLERATE "Audio.samplerate"


class XvidEncoder  {
public:
    XvidEncoder(HINSTANCE dllInstance, HWND owner);
    ~XvidEncoder();

    void showOptions();

    bool onStartEncoding(const char* movieFile);
    bool onStopEncoding();

    void onFrame(const unsigned char* videoFrame, const unsigned char* audioFrame);

public:
    char* getOption(char* key);
    void setOption(char* key, char* value);
    void loadOptions();
    void saveOptions();
    void clearOptions();
    void setDefaultOptions();

private:
    void downsampleAudio(unsigned char* input, int inputNumberSamples, unsigned char* output, int outputNumberSamples);

private:
    HINSTANCE _dllInstance;
    HWND _owner;
    char* _outputFile;
    int _encoderHandle;

    int _videoFrameDivider;
    int _videoFrameCounter;

    int _audioFrameDivider;
    int _audioFrameCounter;
    unsigned char* _audioFrameAccumulation;
    int _audioAccumulationOffset;

    struct ltstr { bool operator()(char* s1, char* s2) const { return strcmp(s1, s2) < 0; } };
    std::map<char*, char*, ltstr> _settings;
};

#endif